from dqc_wrapper.test03_temporal_completeness import TemporalCompletenessTest
from dqc_wrapper import checker
from dqc_wrapper.test_testers.conftest import dirs
import json, pytest
from pathlib import Path

"""UNIT TESTS"""

def test_get_forms_dates():
    test = TemporalCompletenessTest(dirs.nc_file, '', dirs.test_dir, '', 'tas',
                                    '', '')
    response = test.get_forms_dates()
    assert len(response) == 2
    # Exception loading json
    with pytest.raises(Exception):
        test = TemporalCompletenessTest(dirs.nc_file, '', 'fake_dir', '',
                                        'tas', '', '')
        test.get_forms_dates()

    # Exception reading constraints (key 'originating_centre' doesn't exist
    # in fake json)
    with pytest.raises(Exception):
        test = TemporalCompletenessTest(dirs.nc_file, '', dirs.test_dir,
                                        'seasonal', 'tas', '', '')
        test.get_forms_dates()

def test_check_timestamps():
    # Mocked nc is temporal complete
    test = TemporalCompletenessTest(dirs.nc_file, '', dirs.test_dir, '', 'tas',
                                    '', '')
    response = test.check_timestamps()
    assert response[0] == 'ok'

    # Mocked grib isn't
    test = TemporalCompletenessTest(dirs.grib_file, '', dirs.test_dir, '',
                                    'tas', '', '')
    response = test.check_timestamps()
    assert response[0] == 'err'


""" INTEGRATION TESTS """
@pytest.mark.skip
def test_test03():
    # Can't mount shared locally
    checker.main([Path(dirs.test_dir, "../conf/conf_test03_1.ini")])
    assert Path("/tmp/dqc_res/conf_test03_1.ini").exists()

if __name__ == "__main__":
    test_test03()